Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class BuiltInListType

    java.lang.Object
      net.sf.saxon.type.BuiltInListType

All Implemented Interfaces:
  ListType, MappingFunction, SchemaComponent, SchemaType, java.io.Serializable, SimpleType

public class BuiltInListType
extends java.lang.Object
implements ListType, MappingFunction, java.io.Serializable

This class is used to implement the built-in list types NMTOKENS, ENTITIES, IDREFS. In the schema-aware product it is also used to support user-defined list types.

See Also:
  Serialized Form

Field Summary

Fields inherited from interface net.sf.saxon.type.SchemaType
`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION, DERIVE_BY_SUBSTITUTION`

Fields inherited from interface net.sf.saxon.type.SchemaComponent
`FIXED_UP, INCOMPLETE, INVALID, UNVALIDATED, VALIDATED, VALIDATING`

Constructor Summary
`BuiltInListType(int fingerprint)` Create a new ListType.

Method Summary
`boolean` | `allowsDerivation(int derivation)` Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property
`void` | `analyzeContentExpression(Expression expression, int kind, StaticContext env)` Analyze an expression to see whether the expression is capable of delivering a value of this type.
`java.lang.String` | `applyWhitespaceNormalization(java.lang.String value)` Apply the whitespace normalization rules for this simple type
`SchemaType` | `getBaseType()` Returns the base type that this type inherits from.
`int` | `getBlock()` Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`
`SchemaType` | `getBuiltInBaseType()`
`AtomicType` | `getCommonAtomicType()` Get the most specific possible atomic type that all items in this SimpleType belong to
`int` | `getDerivationMethod()` Gets the integer code of the derivation method used to derive this type from its parent.
`java.lang.String` | `getDescription()` Get a description of this type for use in error messages.
`java.lang.String` | `getDisplayName()` Get the display name of the type: that is, a lexical QName with an arbitrary prefix
`int` | `getFingerprint()` Get the fingerprint of the name of this type
`SimpleType` | `getItemType()` Returns the simpleType of the items in this ListType.
`SchemaType` | `getKnownBaseType()` Returns the base type that this type inherits from.
`java.lang.String` | `getLocalName()` Get the local name of this type
`int` | `getNameCode()` Get the namecode of the name of this type.
`SequenceIterator` | `getTypedValue(java.lang.CharSequence value, NamespaceResolver resolver)` Get the typed value of a given input string.
`SequenceIterator` | `getTypedValue(NodeInfo node)` Get the typed value of a node that is annotated with this schema type.
`int` | `getValidationStatus()` Get the validation status - always valid
`int` | `getWhitespaceAction()` Determine how values of this simple type are whitespace-normalized.
`boolean` | `isComplexType()` Test whether this SchemaType is a complex type
`boolean` | `isListType()` Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members
`boolean` | `isNamespaceSensitive()` Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space.
`boolean` | `isSameType(SchemaType other)` Test whether this is the same type as another type.
`boolean` | `isSimpleType()` Test whether this SchemaType is a simple type
`void` | `isTypeDerivationOK(SchemaType type, int block)` Check that this type is validly derived from a given type
`boolean` | `isUnionType()` Test whether this Simple Type is a union type
`java.lang.Object` | `map(Item item, XPathContext context, java.lang.Object info)` The typed value of a list-valued node is obtained by tokenizing the string value and applying a mapping function to the sequence of tokens.
`ValidationException` | `validateContent(java.lang.CharSequence value, NamespaceResolver nsResolver)` Check whether a given input string is valid according to this SimpleType

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BuiltInListType

    public BuiltInListType(int fingerprint)

  Create a new ListType.

Method Detail

### getWhitespaceAction

    public int getWhitespaceAction()

  Determine how values of this simple type are whitespace-normalized.

  Specified by:
    `getWhitespaceAction` in interface `SimpleType`
  Returns:
    one of `Whitespace.PRESERVE`, `Whitespace.COLLAPSE`, `Whitespace.REPLACE`.

### getCommonAtomicType

    public AtomicType getCommonAtomicType()

  Get the most specific possible atomic type that all items in this SimpleType belong to

  Specified by:
    `getCommonAtomicType` in interface `SimpleType`
  Returns:
    the lowest common supertype of all member types

### getValidationStatus

    public int getValidationStatus()

  Get the validation status - always valid

  Specified by:
    `getValidationStatus` in interface `SchemaComponent`
  Returns:
    one of the values `SchemaComponent.UNVALIDATED`, `SchemaComponent.VALIDATING`, `SchemaComponent.VALIDATED`, `SchemaComponent.INVALID`, `SchemaComponent.INCOMPLETE`

### getBaseType

    public SchemaType getBaseType()

  Returns the base type that this type inherits from. If this type is a Simpletype that is a built in primitive type then null is returned.

  Specified by:
    `getBaseType` in interface `SchemaType`
  Returns:
    the base type.

### isListType

    public boolean isListType()

  Returns true if this type is derived by list, or if it is derived by restriction from a list type, or if it is a union that contains a list as one of its members

  Specified by:
    `isListType` in interface `SimpleType`
  Returns:
    true if this is a list type

### isUnionType

    public boolean isUnionType()

  Description copied from interface: `SimpleType`
  Test whether this Simple Type is a union type

  Specified by:
    `isUnionType` in interface `SimpleType`
  Returns:
    true if this is a union type

### getBuiltInBaseType

    public SchemaType getBuiltInBaseType()
                                  throws ValidationException

  Specified by:
    `getBuiltInBaseType` in interface `SimpleType`
  Throws:
    `ValidationException`

### isNamespaceSensitive

    public boolean isNamespaceSensitive()

  Description copied from interface: `SimpleType`
  Test whether this type is namespace sensitive, that is, if a namespace context is needed to translate between the lexical space and the value space. This is true for types derived from, or containing, QNames and NOTATIONs

  Specified by:
    `isNamespaceSensitive` in interface `SimpleType`
  Returns:
    true if the type is namespace-sensitive

### getFingerprint

    public int getFingerprint()

  Get the fingerprint of the name of this type

  Specified by:
    `getFingerprint` in interface `SchemaType`
  Returns:
    the fingerprint. Returns an invented fingerprint for an anonymous type.

### getNameCode

    public int getNameCode()

  Get the namecode of the name of this type. Because built-in types don't depend on the namePool, this actually returns the fingerprint, which contains no information about the namespace prefix

  Specified by:
    `getNameCode` in interface `SchemaType`

### getDisplayName

    public java.lang.String getDisplayName()

  Get the display name of the type: that is, a lexical QName with an arbitrary prefix

  Specified by:
    `getDisplayName` in interface `SchemaType`
  Returns:
    a lexical QName identifying the type

### isComplexType

    public boolean isComplexType()

  Test whether this SchemaType is a complex type

  Specified by:
    `isComplexType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a complex type

### isSimpleType

    public boolean isSimpleType()

  Test whether this SchemaType is a simple type

  Specified by:
    `isSimpleType` in interface `SchemaType`
  Returns:
    true if this SchemaType is a simple type

### getBlock

    public int getBlock()

  Returns the value of the 'block' attribute for this type, as a bit-signnificant integer with fields such as `SchemaType.DERIVATION_LIST` and `SchemaType.DERIVATION_EXTENSION`

  Specified by:
    `getBlock` in interface `SchemaType`
  Returns:
    the value of the 'block' attribute for this type

### getKnownBaseType

    public SchemaType getKnownBaseType()
                                throws java.lang.IllegalStateException

  Returns the base type that this type inherits from. This method can be used to get the base type of a type that is known to be valid. If this type is a Simpletype that is a built in primitive type then null is returned.

  Returns:
    the base type.
  Throws:
    `java.lang.IllegalStateException` - if this type is not valid.

### getDerivationMethod

    public int getDerivationMethod()

  Gets the integer code of the derivation method used to derive this type from its parent. Returns zero for primitive types.

  Specified by:
    `getDerivationMethod` in interface `SchemaType`
  Returns:
    a numeric code representing the derivation method, for example `SchemaType.DERIVATION_RESTRICTION`

### allowsDerivation

    public boolean allowsDerivation(int derivation)

  Determines whether derivation (of a particular kind) from this type is allowed, based on the "final" property

  Specified by:
    `allowsDerivation` in interface `SchemaType`
  Parameters:
    `derivation` - the kind of derivation, for example `SchemaType.DERIVATION_LIST`
  Returns:
    true if this kind of derivation is allowed

### getTypedValue

    public SequenceIterator getTypedValue(NodeInfo node)
                                   throws XPathException

  Get the typed value of a node that is annotated with this schema type. This method must be called only for a valid type.

  Specified by:
    `getTypedValue` in interface `SchemaType`
  Parameters:
    `node` - the node whose typed value is required
  Returns:
    a SequenceIterator over the atomic values making up the typed value of the specified node. The objects returned by this iterator are of type `AtomicValue`
  Throws:
    `XPathException`

### isSameType

    public boolean isSameType(SchemaType other)

  Test whether this is the same type as another type. They are considered to be the same type if they are derived from the same type definition in the original XML representation (which can happen when there are multiple includes of the same file)

  Specified by:
    `isSameType` in interface `SchemaType`

### getDescription

    public java.lang.String getDescription()

  Description copied from interface: `SchemaType`
  Get a description of this type for use in error messages. This is the same as the display name in the case of named types; for anonymous types it identifies the type by its position in a source schema document.

  Specified by:
    `getDescription` in interface `SchemaType`
  Returns:
    text identifing the type, for use in a phrase such as "the type XXXX".

### isTypeDerivationOK

    public void isTypeDerivationOK(SchemaType type,
                                   int block)
                            throws SchemaException,
                                   ValidationException

  Check that this type is validly derived from a given type

  Specified by:
    `isTypeDerivationOK` in interface `SchemaType`
  Parameters:
    `type` - the type from which this type is derived
    `block` - the derivations that are blocked by the relevant element declaration
  Throws:
    `SchemaException` - if the derivation is not allowed
    `ValidationException`

### getLocalName

    public java.lang.String getLocalName()

  Get the local name of this type

  Returns:
    the local part of the name, or null if the type is anonymous

### getItemType

    public SimpleType getItemType()

  Returns the simpleType of the items in this ListType.

  Specified by:
    `getItemType` in interface `ListType`
  Returns:
    the simpleType of the items in this ListType.

### applyWhitespaceNormalization

    public java.lang.String applyWhitespaceNormalization(java.lang.String value)

  Apply the whitespace normalization rules for this simple type

  Parameters:
    `value` - the string before whitespace normalization
  Returns:
    the string after whitespace normalization

### analyzeContentExpression

    public void analyzeContentExpression(Expression expression,
                                         int kind,
                                         StaticContext env)
                                  throws XPathException

  Analyze an expression to see whether the expression is capable of delivering a value of this type.

  Specified by:
    `analyzeContentExpression` in interface `SchemaType`
  Parameters:
    `expression` - the expression that delivers the content
    `kind` - the node kind whose content is being delivered: `Type.ELEMENT`, `Type.ATTRIBUTE`, or `Type.DOCUMENT`
    `env` -
  Throws:
    `XPathException` - if the expression will never deliver a value of the correct type

### validateContent

    public ValidationException validateContent(java.lang.CharSequence value,
                                               NamespaceResolver nsResolver)

  Check whether a given input string is valid according to this SimpleType

  Specified by:
    `validateContent` in interface `SimpleType`
  Parameters:
    `value` - the input string to be checked
    `nsResolver` - a namespace resolver used to resolve namespace prefixes if the type is namespace sensitive. The value supplied may be null; in this case any namespace-sensitive content will throw an UnsupportedOperationException.
  Returns:
    null if validation succeeds; return a ValidationException describing the validation failure if validation fails. Note that the exception is returned rather than being thrown.
  Throws:
    `java.lang.UnsupportedOperationException` - if the type is namespace-sensitive and no namespace resolver is supplied

### getTypedValue

    public SequenceIterator getTypedValue(java.lang.CharSequence value,
                                          NamespaceResolver resolver)
                                   throws ValidationException

  Get the typed value of a given input string. This method assumes that the input value is valid according to this SimpleType

  Specified by:
    `getTypedValue` in interface `SimpleType`
  Parameters:
    `value` - the string whose typed value is required
    `resolver` -
  Returns:
    an iterator over the atomic sequence comprising the typed value. The objects returned by this SequenceIterator will all be of type `AtomicValue`
  Throws:
    `ValidationException`

### map

    public java.lang.Object map(Item item,
                                XPathContext context,
                                java.lang.Object info)
                         throws XPathException

  The typed value of a list-valued node is obtained by tokenizing the string value and applying a mapping function to the sequence of tokens. This method implements the mapping function. It is for internal use only. For details see `MappingFunction`

  Specified by:
    `map` in interface `MappingFunction`
  Parameters:
    `item` - The item to be mapped. If context is supplied, this must be the same as context.currentItem().
    `context` - The processing context. This is supplied only for mapping constructs that set the context node, position, and size. Otherwise it is null.
    `info` - Arbitrary information supplied by the creator of the MappingIterator. It must be read-only and immutable for the duration of the iteration.
  Returns:
    either (a) a SequenceIterator over the sequence of items that the supplied input item maps to, or (b) an Item if it maps to a single item, or (c) null if it maps to an empty sequence.
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD